Package ru.bitel.bgbilling.kernel.customer.common.service

# Interface CustomerService

public interface CustomerService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `CustomerAccount`
  `customerAccountAdd(int customerId, long account)`
  `void`
  `customerAccountDelete(int customerId, long account)`
  `List<CustomerAccount>`
  `customerAccounts(int customerId)`
  `void`
  `customerAccountSet(int customerId, int contractId, long account)`
  `String`
  `customerBankUpdate(int customerId, String text)`
  `Customer`
  `customerByAccount(long account)`
  `String`
  `customerContactUpdate(int customerId, CustomerContactType contactType, String text)`
  `List<CustomerContract>`
  `customerContracts(int customerId, LocalDateTime onTime)`
  `void`
  `customerDelete(int customerId)`
  `List<String>`
  `customerEmails(int customerId, int contractId)`
  `String`
  `customerEmployeeDelete(int customerId, String customerEmployeeUUID)`
  `List<CustomerEmployee>`
  `customerEmployeeList(int customerId)`
  `String`
  `customerEmployeeUpdate(int customerId, CustomerEmployee customerEmployee)`
  `void`
  `customerLinkSet(int contractId, int сustomerId)`
  `int`
  `customerNewSet(int contractId)`
  `String`
  `customerParameterGet(int contractId)`
  `String`
  `customerParameterHistory(int customerId, String fieldKey, int lastRecordCount)`
  `String`
  `customerParameterUpdate(int customerId, String fieldValue, String text)`
  `List<CustomerPropertyParam>`
  `customerPropertyParams(int customerId)`
  `String`
  `customerSearch(Customer.CustomerType customerType, String text)`
  Поиск клиентов
  `boolean`
  `customerUnlinkContract(int contractId, LocalDateTime unlinkTime)`
  `SearchResult<Customer>`
  `searchCustomerList(Customer.CustomerType customerType, List<ru.bitel.bgbilling.common.model.KeyValue> filters, Page page, String[] sort)`

- ## Method Details

  - ### customerEmployeeList

    List<CustomerEmployee> customerEmployeeList(int customerId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerEmployeeUpdate

    String customerEmployeeUpdate(int customerId, CustomerEmployee customerEmployee) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerEmployeeDelete

    String customerEmployeeDelete(int customerId, String customerEmployeeUUID) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerByAccount

    Customer customerByAccount(long account) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### searchCustomerList

    SearchResult<Customer> searchCustomerList(Customer.CustomerType customerType, List<ru.bitel.bgbilling.common.model.KeyValue> filters, Page page, String[] sort) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerAccounts

    List<CustomerAccount> customerAccounts(int customerId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerAccountAdd

    CustomerAccount customerAccountAdd(int customerId, long account) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerAccountSet

    void customerAccountSet(int customerId, int contractId, long account) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerAccountDelete

    void customerAccountDelete(int customerId, long account) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerParameterGet

    String customerParameterGet(int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerParameterUpdate

    String customerParameterUpdate(int customerId, String fieldValue, String text) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerContactUpdate

    String customerContactUpdate(int customerId, CustomerContactType contactType, String text) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerBankUpdate

    String customerBankUpdate(int customerId, String text) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerNewSet

    int customerNewSet(int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerDelete

    void customerDelete(int customerId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerSearch

    String customerSearch(Customer.CustomerType customerType, String text) throws ru.bitel.bgbilling.common.BGException
    Поиск клиентов
    Parameters:
      `customerType` -
      true - ищем юр. лиц
      false - ищем физ. лиц
      `text` -
      строка поиска, в зависимости от содержимого строки и значения параметра uPerson ищет по ИНН, серии и номеру паспорта, огрн, названию, дате рождения и дате выдачи паспорта
    Returns:
      json array
    Throws:
      `Exception`
      `ru.bitel.bgbilling.common.BGException`

  - ### customerLinkSet

    void customerLinkSet(int contractId, int сustomerId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerContracts

    List<CustomerContract> customerContracts(int customerId, LocalDateTime onTime) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerUnlinkContract

    boolean customerUnlinkContract(int contractId, LocalDateTime unlinkTime) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerParameterHistory

    String customerParameterHistory(int customerId, String fieldKey, int lastRecordCount) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerEmails

    List<String> customerEmails(int customerId, int contractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### customerPropertyParams

    List<CustomerPropertyParam> customerPropertyParams(int customerId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`